//
//  AppDelegate.m
//  locallocationnotify
//
//  Created by iPhone Developer on 2013/11/14.
//  Copyright (c) 2013年 iPhone Developer. All rights reserved.
//

#import "AppDelegate.h"

@implementation AppDelegate
@synthesize viewController = _viewController;

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    // Override point for customization after application launch.
    // アプリケーションが停止した状態でLocal Notificationを受信すると通知は一旦iOSに送られ、ダイアログやバナーへと表示された通知がタップされるとアプリケーションが起動され、このメソッドが呼び出されます。
    NSLog(@"didFinishLaunchingWithOptions: %@", launchOptions);
    
    // アプリケーションがLocal Notificationを受信した際に表示されたダイアログやバナー、あるいはロックスクリーンから起動されたならばUILocalNotificationのインスタンスがlaunchOptionsに格納されている
    UILocalNotification *localNotification = [launchOptions objectForKey:UIApplicationLaunchOptionsLocalNotificationKey];
    if ( localNotification ) {
        // アプリケーションはLocal Notificationによって起動された
        NSLog(@"localNotification: %@", localNotification);
        NSDictionary *userInfo = [localNotification userInfo];
        NSString *extraInfo = [userInfo objectForKey:@"ExtraInfo"];
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Local Notificationから起動されました" message:extraInfo delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alertView performSelector:@selector(show) withObject:nil afterDelay:0.0];
    }
    return YES;
}
							
- (void)applicationWillResignActive:(UIApplication *)application
{
    // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
    // Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
    // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
    [_viewController setRunBackground:YES];
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    // Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
    [_viewController setRunBackground:NO];
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
}

- (void)application:(UIApplication *)application didReceiveLocalNotification:(UILocalNotification *)notification
{
    // アプリケーションがフォアグラウンドにある、またはバックグラウンドで起動した状態でLocal Notificationを受信するとこのdeligateが呼ばれます
    // 過去のLocal Notificationがクリックされてこのdelegateが呼び出された場合にはnotificationがnilとなっているので注意が必要です
    if ( notification ) {
        NSLog(@"didReceiveLocalNotification: %@", notification);
        NSDictionary *userInfo = [notification userInfo];
        NSString *extraInfo = [userInfo objectForKey:@"ExtraInfo"];
        UIAlertView *alertView = [[UIAlertView alloc] initWithTitle:@"Local Notificationを受信しました" message:extraInfo delegate:nil cancelButtonTitle:nil otherButtonTitles:@"OK", nil];
        [alertView performSelector:@selector(show) withObject:nil afterDelay:0.0];
    }
}

@end
