//
//  ViewController.m
//  localnotification
//
//  Created by iPhone Developer on 2013/11/12.
//  Copyright (c) 2013年 iPhone Developer. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()
- (IBAction)actionSendNotification;
@end

@implementation ViewController

- (void)viewDidLoad
{
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

// 「プッシュする」ボタンがタップされた場合に呼び出されるアクション
- (IBAction)actionSendNotification
{
    // UILocalNotificationのクラスインスタンスを生成
    UILocalNotification *localNotification = [[UILocalNotification alloc] init];
    // foreDateは20秒後
    localNotification.fireDate = [[NSDate date] dateByAddingTimeInterval:20];
    // タイムゾーンは端末に設定されているタイムゾーン
    localNotification.timeZone = [NSTimeZone defaultTimeZone];
    // アラートには「これはLocal Notificationです」を表示する
    localNotification.alertBody = @"これはLocal Notificationです";
    // アクションボタンあり
    localNotification.hasAction = YES;
    // アクションボタンには「アプリを起動」する
    localNotification.alertAction = @"アプリを起動";
    // 通知を受信したらデフォルトの通知音を鳴らす
    localNotification.soundName = UILocalNotificationDefaultSoundName;
    // アプリケーションアイコンのバッジに「１」を表示する
    localNotification.applicationIconBadgeNumber = 1;
    // アプリケーション独自の情報としてディクショナリを送信(受信時の処理は自分で実装しなければならない)
    NSDictionary *userInfo = [NSDictionary dictionaryWithObject:@"通知を受信しました。" forKey:@"ExtraInfo"];
    localNotification.userInfo = userInfo;
    // Local Notificationをスケジュール
    [[UIApplication sharedApplication] scheduleLocalNotification:localNotification];
}

@end
