<?php

$E = error_reporting();
if(($E & E_STRICT) == E_STRICT) error_reporting($E ^ E_STRICT);

require_once 'configure.php';
require_once 'MDB2.php';
require_once 'Log.php';

//
// IN:(POST)
//   app_name : アプリケーションの名称
//   app_version : アプリケーションのバージョン
//   device_uuid : デバイスユニークID
//   device_token : デバイストークン
//   device_name : デバイス名
//   device_model : デバイスのモデル
//   device_version : デバイスのバージョン
//   push_badge : バッジの有効状態(0:無効、1:有効)
//   push_alert : アラートの有効状態(0:無効、1:有効)
//   push_sound : サウンドの有効状態(0:無効、1:有効)
//
// OUT:(json)
//   error_no : エラーコード
//   error_msg : エラーメッセージ
//
function register_apns() {
            try {

                $logfile = &Log::factory('file', 'debug.log', 'DEBUG');

                $app_name = $_REQUEST['app_name'];
                $app_version = $_REQUEST['app_version'];
                $device_uuid = $_REQUEST['device_uuid'];
                $device_token = $_REQUEST['device_token'];
                $device_name = $_REQUEST['device_name'];
                $device_model = $_REQUEST['device_model'];
                $device_version = $_REQUEST['device_version'];
                $push_badge = $_REQUEST['push_badge'];
                $push_alert = $_REQUEST['push_alert'];
                $push_sound = $_REQUEST['push_sound'];

                $logfile->log('register_device()');
                $logfile->log('app_name:'.$app_name);
                $logfile->log('app_version:'.$app_version);
                $logfile->log('device_uuid:'.$device_uuid);
                $logfile->log('device_token:'.$device_token);
                $logfile->log('device_name:'.$device_name);
                $logfile->log('device_model:'.$device_model);
                $logfile->log('device_version:'.$device_version);
                $logfile->log('push_badge:'.$push_badge);
                $logfile->log('push_alert:'.$push_alert);
                $logfile->log('push_sound:'.$push_sound);

                $ldb =& MDB2::factory(DATABASE, array('debug' => 2, 'result_buffering' => false));

                $params1 = array();
                $sql1 = 'SELECT seq_id FROM device_info WHERE device_uuid=:device_uuid';
                $stmt1 = $ldb->prepare($sql1);
                if ( PEAR::isError($stmt1) ) {
            throw new exception($stmt1->getMessage(), EC_DATABASE_ERROR);
                }

                $params1['device_uuid'] = $device_uuid;

                $rs1 = $stmt1->execute($params1);
                if ( PEAR::isError($rs1) ) {
            throw new exception($rs1->getMessage(), EC_DATABASE_ERROR);
                }

                $do_insert = 1;
                if ( $row1 = $rs1->fetchRow(MDB2_FETCHMODE_OBJECT) ) {
            $do_insert = 0; // UPDATE
            $seq_id = $row1->seq_id;
                }
                $rs1->free();
                $stmt1->free();
                $logfile->log('seq_id:'.$seq_id);

                $params2 = array();
                if ( $do_insert ) {
            $sql2 = 'INSERT INTO device_info (';
            $sql2 .= 'app_name, ';
            $sql2 .= 'app_version, ';
            $sql2 .= 'device_uuid, ';
            $sql2 .= 'device_token, ';
            $sql2 .= 'device_name, ';
            $sql2 .= 'device_model, ';
            $sql2 .= 'device_version, ';
            $sql2 .= 'push_badge, ';
            $sql2 .= 'push_alert, ';
            $sql2 .= 'push_sound, ';
            $sql2 .= 'current_location, ';
            $sql2 .= 'created_on';
            $sql2 .= ') VALUES (';
            $sql2 .= ':app_name, ';
            $sql2 .= ':app_version, ';
            $sql2 .= ':device_uuid, ';
            $sql2 .= ':device_token, ';
            $sql2 .= ':device_name, ';
            $sql2 .= ':device_model, ';
            $sql2 .= ':device_version, ';
            $sql2 .= ':push_badge, ';
            $sql2 .= ':push_alert, ';
            $sql2 .= ':push_sound, ';
            $sql2 .= "GeomFromText('POINT(0.0 0.0)'), ";
            $sql2 .= ':created_on';
            $sql2 .= ')';

            $params2['app_name'] = $app_name;
            $params2['app_version'] = $app_version;
            $params2['device_uuid'] = $device_uuid;
            $params2['device_token'] = $device_token;
            $params2['device_name'] = $device_name;
            $params2['device_model'] = $device_model;
            $params2['device_version'] = $device_version;
            $params2['push_badge'] = $push_badge;
            $params2['push_alert'] = $push_alert;
            $params2['push_sound'] = $push_sound;
            $params2['created_on'] = date('Y-m-d H:i:s');
                }
                else {
            $sql2 = 'UPDATE device_info SET ';
            $sql2 .= 'app_name = :app_name, ';
            $sql2 .= 'app_version = :app_version, ';
            $sql2 .= 'device_token = :device_token, ';
            $sql2 .= 'device_name = :device_name, ';
            $sql2 .= 'device_model = :device_model, ';
            $sql2 .= 'device_version = :device_version, ';
            $sql2 .= 'push_badge = :push_badge, ';
            $sql2 .= 'push_alert = :push_alert, ';
            $sql2 .= 'push_sound = :push_sound, ';
            $sql2 .= 'updated_on = :updated_on ';
            $sql2 .= 'WHERE seq_id=:seq_id';

            $params2['app_name'] = $app_name;
            $params2['app_version'] = $app_version;
            $params2['device_token'] = $device_token;
            $params2['device_name'] = $device_name;
            $params2['device_model'] = $device_model;
            $params2['device_version'] = $device_version;
            $params2['push_badge'] = $push_badge;
            $params2['push_alert'] = $push_alert;
            $params2['push_sound'] = $push_sound;
            $params2['updated_on'] = date('Y-m-d H:i:s');
            $params2['seq_id'] = $seq_id;
                }

                $logfile->log('sql: ' . $sql2);
                $stmt2 = $ldb->prepare($sql2);
                if ( PEAR::isError($stmt2) ) {
            throw new systemException($stmt2->getMessage(), EC_DATABASE_ERROR);
                }

                $rs2 = $stmt2->execute($params2);
                if ( PEAR::isError($rs2) ) {
            throw new exception($rs2->getMessage(), EC_DATABASE_ERROR);
                }
                //$ldb->commit();
                $rs2->free();
                $stmt2->free();

                $response = array(
            "error_no" => 0,
            "error_msg"  => "No Error."
                );

                $logfile->log('No Error');
                $encode = json_encode($response);
                $logfile->log('encode:'.$encode);
                header("Content-Type: text/javascript; charset=utf-8");
                echo $encode;
            }
            catch ( Exception $e ) {
                $logfile->log('Error:' . $e->getMessage());
                $response = array(
            "error_no" => $e->getCode(),
            "error_msg"  => $e->getMessage()
                );
                $encode = json_encode($response);
                header("Content-Type: text/javascript; charset=utf-8");
                echo $encode;
            }
}

register_apns();

?>
